"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Context = void 0;
const uuid_1 = require("uuid");
const types_1 = require("../../common/types");
const config_1 = require("../../common/config");
const error_1 = require("../../error");
const default_1 = require("../../common/default");
class Context extends default_1.Default {
    constructor(mode, msgType, id, creation) {
        error_1.ContextError.checkLength(id, config_1.MAX_ID_LENGTH);
        super();
        this.id = id || uuid_1.v4();
        this.mode = mode;
        this.msgType = msgType;
        this.creation = (creation || new Date()).toISOString();
    }
    addLinks(links) {
        if (!this.link)
            this.link = new Array();
        this.link.push(...links);
        return this;
    }
    setLevel(level) {
        this.level = level;
        return this;
    }
    setSecurityClassification(seClass) {
        this.seClass = seClass;
        return this;
    }
    setFreeText(freeText) {
        error_1.ContextError.checkLength(freeText, config_1.MAX_FREETEXT_LENGTH);
        this.freeText = freeText;
        return this;
    }
    setUrgency(urgency) {
        this.urgency = urgency;
        return this;
    }
    setOrigin(origin) {
        this.origin = origin;
        return this;
    }
    addExternalInfos(externals) {
        if (!this.externalInfo)
            this.externalInfo = new Array();
        this.externalInfo.push(...externals);
        return this;
    }
    static default() {
        return new Context(types_1.Mode.SYSTEM, types_1.MsgType.ERROR, config_1.NULL_UUID);
    }
}
__decorate([
    default_1.IdentifyArrayProperty(default_1.TypeOfArray.OBJECT_ARRAY),
    __metadata("design:type", Array)
], Context.prototype, "link", void 0);
__decorate([
    default_1.IdentifyArrayProperty(default_1.TypeOfArray.OBJECT_ARRAY),
    __metadata("design:type", Array)
], Context.prototype, "externalInfo", void 0);
__decorate([
    default_1.IndexDefaultMethod(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Context)
], Context, "default", null);
exports.Context = Context;
