"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EGeo = void 0;
const config_1 = require("../../common/config");
const default_1 = require("../../common/default");
const error_1 = require("../../error");
class EGeo extends default_1.Default {
    constructor(type, position) {
        error_1.EventError.checkLength(type, config_1.MAX_ETYPE_LENGTH);
        super();
        this.type = type;
        this.position = position;
    }
    setDatime(datime) {
        this.datime = datime;
        return this;
    }
    addWeather(weathers) {
        weathers.forEach(weather => error_1.EventError.checkLength(weather, config_1.MAX_WEATHER_LENGTH));
        if (!this.weather)
            this.weather = new Array();
        this.weather.push(...weathers);
        return this;
    }
    setFreeText(freeText) {
        error_1.EventError.checkLength(freeText, config_1.MAX_FREETEXT_LENGTH);
        this.freeText = freeText;
        return this;
    }
    setId(id) {
        error_1.EventError.checkLength(id, config_1.MAX_ID_LENGTH);
        this.id = id;
        return this;
    }
    setStatus(status) {
        this.status = status;
        return this;
    }
    static default() {
        return new EGeo('');
    }
}
__decorate([
    default_1.IdentifyArrayProperty(default_1.TypeOfArray.STRING_ARRAY),
    __metadata("design:type", Array)
], EGeo.prototype, "weather", void 0);
__decorate([
    default_1.IndexDefaultMethod(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", EGeo)
], EGeo, "default", null);
exports.EGeo = EGeo;
