"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Event = void 0;
const uuid_1 = require("uuid");
const config_1 = require("../../common/config");
const error_1 = require("../../error");
const default_1 = require("../../common/default");
class Event extends default_1.Default {
    constructor(id, name, mainEventId) {
        error_1.EventError.checkLength(id, config_1.MAX_ID_LENGTH);
        error_1.EventError.checkLength(name, config_1.MAX_NAME_LENGTH);
        error_1.EventError.checkLength(mainEventId, config_1.MAX_ID_LENGTH);
        super();
        this.id = id || uuid_1.v4();
        this.name = name;
        this.mainEventId = mainEventId;
    }
    setEventType(eType) {
        this.eType = eType;
        return this;
    }
    setSource(source) {
        this.source = source;
        return this;
    }
    setScale(scale) {
        this.scale = scale;
        return this;
    }
    setCertainly(certainly) {
        if (certainly < 0 || certainly > 100)
            throw new error_1.EventError(`Field "certainly" must be between 0 and 100 included`);
        this.certainly = certainly;
        return this;
    }
    setDeclDatime(decl) {
        this.declDatime = decl;
        return this;
    }
    setOccDatime(occ) {
        this.occDatime = occ;
        return this;
    }
    setObsDatime(obs) {
        this.obsDatime = obs;
        return this;
    }
    setStatus(status) {
        this.status = status;
        return this;
    }
    setRiskAssessmnt(risk) {
        this.riskAssessmnt = risk;
        return this;
    }
    addReferences(references) {
        if (!this.reference)
            this.reference = new Array();
        this.reference.push(...references);
        return this;
    }
    addCasualties(casualties) {
        if (!this.casualties)
            this.casualties = new Array();
        this.casualties.push(...casualties);
        return this;
    }
    addEventGeos(eGeo) {
        if (!this.eGeo)
            this.eGeo = new Array();
        this.eGeo.push(...eGeo);
        return this;
    }
    setCause(cause) {
        this.cause = cause;
        return this;
    }
    setFreeText(freeText) {
        error_1.EventError.checkLength(freeText, config_1.MAX_FREETEXT_LENGTH);
        this.freeText = freeText;
        return this;
    }
    static default() {
        return new Event(config_1.NULL_UUID);
    }
}
__decorate([
    default_1.IdentifyArrayProperty(default_1.TypeOfArray.OBJECT_ARRAY),
    __metadata("design:type", Array)
], Event.prototype, "reference", void 0);
__decorate([
    default_1.IdentifyArrayProperty(default_1.TypeOfArray.OBJECT_ARRAY),
    __metadata("design:type", Array)
], Event.prototype, "casualties", void 0);
__decorate([
    default_1.IdentifyArrayProperty(default_1.TypeOfArray.OBJECT_ARRAY),
    __metadata("design:type", Array)
], Event.prototype, "eGeo", void 0);
__decorate([
    default_1.IndexDefaultMethod(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Event)
], Event, "default", null);
exports.Event = Event;
