"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Reference = void 0;
const config_1 = require("../../common/config");
const default_1 = require("../../common/default");
const error_1 = require("../../error");
class Reference extends default_1.Default {
    constructor(orgId, otherEventIds) {
        error_1.EventError.checkLength(orgId, config_1.MAX_ID_LENGTH);
        otherEventIds.forEach(eventId => error_1.EventError.checkLength(eventId, config_1.MAX_ID_LENGTH));
        super();
        this.orgId = orgId;
        this.otherEventId = otherEventIds;
    }
    static default() {
        return new Reference(config_1.NULL_UUID, []);
    }
}
__decorate([
    default_1.IdentifyArrayProperty(default_1.TypeOfArray.STRING_ARRAY),
    __metadata("design:type", Array)
], Reference.prototype, "otherEventId", void 0);
__decorate([
    default_1.IndexDefaultMethod(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Reference)
], Reference, "default", null);
exports.Reference = Reference;
