"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Coord = void 0;
const default_1 = require("../../common/default");
const error_1 = require("../../error");
class Coord extends default_1.Default {
    constructor(lat, lon, height) {
        if (lat < -90 || lat > 90)
            throw new error_1.PositionError('Latitude must be between -90 and +90 degrees');
        if (lon < -180 || lon > 180)
            throw new error_1.PositionError('Longitude must be between -180 and +180 degrees');
        super();
        this.lat = lat;
        this.lon = lon;
        this.height = height;
    }
    static default() {
        return new Coord(0, 0);
    }
}
__decorate([
    default_1.IndexDefaultMethod(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Coord)
], Coord, "default", null);
exports.Coord = Coord;
