"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Position = void 0;
const config_1 = require("../../common/config");
const default_1 = require("../../common/default");
const error_1 = require("../../error");
class Position extends default_1.Default {
    constructor(locId, name, type) {
        if (!locId && !name && !type)
            throw new error_1.PositionError(`All first level elements of 'Position' are optional, but at least one should be provided.`);
        super();
        this.locId = locId;
        this.name = name;
        this.type = type;
        this.coordSys = config_1.COORDSYS;
    }
    setHeightRole(heightRole) {
        this.heightRole = heightRole;
        return this;
    }
    addCoords(coords) {
        if (!this.coord)
            this.coord = new Array();
        this.coord.push(...coords);
        return this;
    }
    addAddresses(addresses) {
        addresses.forEach(add => error_1.PositionError.checkLength(add, config_1.MAX_ADDRESS_LENGTH));
        if (!this.address)
            this.address = new Array();
        this.address.push(...addresses);
        return this;
    }
    static default() {
        return new Position(config_1.NULL_UUID);
    }
}
__decorate([
    default_1.IdentifyArrayProperty(default_1.TypeOfArray.OBJECT_ARRAY),
    __metadata("design:type", Array)
], Position.prototype, "coord", void 0);
__decorate([
    default_1.IdentifyArrayProperty(default_1.TypeOfArray.STRING_ARRAY),
    __metadata("design:type", Array)
], Position.prototype, "address", void 0);
__decorate([
    default_1.IndexDefaultMethod(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Position)
], Position, "default", null);
exports.Position = Position;
