"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RType = void 0;
const config_1 = require("../../common/config");
const default_1 = require("../../common/default");
const error_1 = require("../../error");
class RType extends default_1.Default {
    constructor(classes) {
        classes.forEach((add) => error_1.ResourceError.checkLength(add, config_1.MAX_RTYPE_LENGTH));
        super();
        this.class = classes;
    }
    addCapabilities(capabilities) {
        capabilities.forEach((add) => error_1.ResourceError.checkLength(add, config_1.MAX_RTYPE_LENGTH));
        if (!this.capability)
            this.capability = new Array();
        this.capability.push(...capabilities);
        return this;
    }
    addCharacteristics(characteristics) {
        characteristics.forEach((add) => error_1.ResourceError.checkLength(add, config_1.MAX_RTYPE_LENGTH));
        if (!this.characteristics)
            this.characteristics = new Array();
        this.characteristics.push(...characteristics);
        return this;
    }
    static default() {
        return new RType(['']);
    }
}
__decorate([
    default_1.IdentifyArrayProperty(default_1.TypeOfArray.STRING_ARRAY),
    __metadata("design:type", Array)
], RType.prototype, "class", void 0);
__decorate([
    default_1.IdentifyArrayProperty(default_1.TypeOfArray.STRING_ARRAY),
    __metadata("design:type", Array)
], RType.prototype, "capability", void 0);
__decorate([
    default_1.IdentifyArrayProperty(default_1.TypeOfArray.STRING_ARRAY),
    __metadata("design:type", Array)
], RType.prototype, "characteristics", void 0);
__decorate([
    default_1.IndexDefaultMethod(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", RType)
], RType, "default", null);
exports.RType = RType;
