"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Resource = void 0;
const config_1 = require("../../common/config");
const default_1 = require("../../common/default");
const resource_error_1 = require("../../error/resource.error");
const resource_type_1 = require("./resource-type");
class Resource extends default_1.Default {
    constructor(rTypes, id) {
        if (rTypes.length === 0)
            throw new resource_error_1.ResourceError('Description of resource is required');
        resource_error_1.ResourceError.checkLength(id, config_1.MAX_RESOURCE_ID_LENGTH);
        super();
        this.rType = rTypes;
        this.id = id;
    }
    setOrgId(orgId) {
        resource_error_1.ResourceError.checkLength(orgId, config_1.MAX_ID_LENGTH);
        this.orgId = orgId;
        return this;
    }
    setName(name) {
        resource_error_1.ResourceError.checkLength(name, config_1.MAX_NAME_LENGTH);
        this.name = name;
        return this;
    }
    setFreeText(freeText) {
        resource_error_1.ResourceError.checkLength(freeText, config_1.MAX_FREETEXT_LENGTH);
        this.freeText = freeText;
        return this;
    }
    addResourceGeos(rgeos) {
        if (!this.rGeo)
            this.rGeo = new Array();
        this.rGeo.push(...rgeos);
        return this;
    }
    setQuantity(quantity) {
        this.quantity = quantity;
        return this;
    }
    setUnitOfMeasure(unit) {
        this.um = unit;
        return this;
    }
    setStatus(status) {
        this.status = status;
        return this;
    }
    setNationality(nationality) {
        this.nationality = nationality.substring(0, 2).toUpperCase();
        return this;
    }
    addContacts(contacts) {
        if (!this.contact)
            this.contact = new Array();
        this.contact.push(...contacts);
        return this;
    }
    static default() {
        return new Resource([resource_type_1.RType.default()]);
    }
}
__decorate([
    default_1.IdentifyArrayProperty(default_1.TypeOfArray.OBJECT_ARRAY),
    __metadata("design:type", Array)
], Resource.prototype, "rType", void 0);
__decorate([
    default_1.IdentifyArrayProperty(default_1.TypeOfArray.OBJECT_ARRAY),
    __metadata("design:type", Array)
], Resource.prototype, "rGeo", void 0);
__decorate([
    default_1.IdentifyArrayProperty(default_1.TypeOfArray.OBJECT_ARRAY),
    __metadata("design:type", Array)
], Resource.prototype, "contact", void 0);
__decorate([
    default_1.IndexDefaultMethod(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Resource)
], Resource, "default", null);
exports.Resource = Resource;
